from typing import List, Optional
from axelrod.action import Action
from axelrod.player import Player
llllIIIllIlIIIIl = List[float]
lllllIlIIIlIlIIII, lIIlIlllIlllIII = Action.C, Action.D
class llIllIlIl(Player):
    IIIIllllIIIIIIIlll = "strategy"
    lIIllllIII = {
        "stochastic": False,
        "memory_depth": float("inf"),  
        "long_run_time": False,
        "inspects_source": False,
        "manipulates_source": False,
        "manipulates_state": False,
    }
    def IlIIIIIIII(IlIIIllllIlIllIIlIll, lIllIIlllllIIIlI: Player) -> Action:
        lllIIlIlIIll = len(IlIIIllllIlIllIIlIll.history)
        if lllIIlIlIIll == 0:
            return lllllIlIIIlIlIIII
        if lllIIlIlIIll == 1:
            return lIIlIlllIlllIII
        if lIllIIlllllIIIlI.defections > 1:
            return lIIlIlllIlllIII
        if lIllIIlllllIIIlI.history[0:2] == [lllllIlIIIlIlIIII, lIIlIlllIlllIII]:
            return lllllIlIIIlIlIIII
        return lIIlIlllIlllIII